package client

import (
	"time"

	"git.loafle.net/commons_go/rpc/protocol"
	crr "git.loafle.net/commons_go/rpc/registry"
	cuc "git.loafle.net/commons_go/util/context"
)

type ClientHandler interface {
	ClientContext(parent cuc.Context) ClientContext

	Init(clientCTX ClientContext) error
	Destroy(clientCTX ClientContext)

	GetCodec() protocol.ClientCodec
	GetRPCInvoker() crr.RPCInvoker
	GetRequestTimeout() time.Duration
	GetPendingRequests() int
	GetRequestID() uint64
	Validate()
}
